# General-purpose Photovoltaic Device Model gpvdm.com - a drift diffusion
# base/Shockley-Read-Hall model for 1st, 2nd and 3rd generation solarcells.
# The model can simulate OLEDs, Perovskite cells, and OFETs.
# 
# Copyright (C) 2008-2020 Roderick C. I. MacKenzie
# All rights reserved.
# 
# https://www.gpvdm.com
# r.c.i.mackenzie at googlemail.com
# 
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#     * Redistributions of source code must retain the above copyright
#       notice, this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above copyright
#       notice, this list of conditions and the following disclaimer in the
#       documentation and/or other materials provided with the distribution.
#     * Neither the name of the GPVDM nor the
#       names of its contributors may be used to endorse or promote products
#       derived from this software without specific prior written permission.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL Roderick C. I. MacKenzie BE LIABLE FOR ANY
# DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.


import os
import shutil
import re
from dat_file_class import dat_file


def dat_file_max_min(my_data):
	my_max=False
	my_min=False

	if my_data.x_len>0 and my_data.y_len>0 and my_data.z_len>0:
		my_max=my_data.data[0][0][0]
		my_min=my_data.data[0][0][0]

		for z in range(0,my_data.z_len):
			for x in range(0,my_data.x_len):
				for y in range(0,my_data.y_len):

					if my_data.data[z][x][y]>my_max:
						my_max=my_data.data[z][x][y]

					if my_data.data[z][x][y]<my_min:
						my_min=my_data.data[z][x][y]

	return [my_max,my_min]


def dat_file_sub(my_data,one):
	if (my_data.x_len==one.x_len) and (my_data.y_len==one.y_len) and (my_data.z_len==one.z_len):
		for z in range(0,my_data.z_len):
			for x in range(0,my_data.x_len):
				for y in range(0,my_data.y_len):
					my_data.data[z][x][y]=my_data.data[z][x][y]-one.data[z][x][y]

def dat_file_sub_float(my_data,val):
		for z in range(0,my_data.z_len):
			for x in range(0,my_data.x_len):
				for y in range(0,my_data.y_len):
					my_data.data[z][x][y]=my_data.data[z][x][y]-val

def dat_file_mul(my_data,val):
		for z in range(0,my_data.z_len):
			for x in range(0,my_data.x_len):
				for y in range(0,my_data.y_len):
					my_data.data[z][x][y]*=val
