# General-purpose Photovoltaic Device Model gpvdm.com - a drift diffusion
# base/Shockley-Read-Hall model for 1st, 2nd and 3rd generation solarcells.
# The model can simulate OLEDs, Perovskite cells, and OFETs.
# 
# Copyright (C) 2008-2020 Roderick C. I. MacKenzie
# All rights reserved.
# 
# https://www.gpvdm.com
# r.c.i.mackenzie at googlemail.com
# 
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#     * Redistributions of source code must retain the above copyright
#       notice, this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above copyright
#       notice, this list of conditions and the following disclaimer in the
#       documentation and/or other materials provided with the distribution.
#     * Neither the name of the GPVDM nor the
#       names of its contributors may be used to endorse or promote products
#       derived from this software without specific prior written permission.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL Roderick C. I. MacKenzie BE LIABLE FOR ANY
# DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.


from win_lin import running_on_linux
import hashlib
from inp import inp_get_token_value
enable_crypto=False
try:
	from Crypto.Cipher import AES
	enable_crypto=True
except:
	pass
iv=""
key=""

def encrypt_load():
	global key
	global iv
	if running_on_linux()==True:
		iv=inp_get_token_value("cluster.inp","#iv")
		key=inp_get_token_value("cluster.inp","#key")

def encrypt(data):
	return data
	global key
	global iv
	global enable_crypto
	if enable_crypto==True:
		ret=""
		m = hashlib.md5()
		m.update(key.encode('utf-8'))
		key_hash=m.digest()

		m = hashlib.md5()
		m.update(iv.encode('utf-8'))
		iv_hash=m.digest()

		encryptor = AES.new(key_hash, AES.MODE_CBC, IV=iv_hash)

		ret= encryptor.encrypt(bytes(data[0:512]))

		encryptor = AES.new(key_hash, AES.MODE_CBC, IV=iv_hash)

		ret=ret+encryptor.encrypt(bytes(data[512:len(data)]))

	return ret


def decrypt(data):
	return data
	global key
	global iv
	global enable_crypto
	if enable_crypto==True:
		ret=""
		m = hashlib.md5()
		m.update(key.encode('utf-8'))
		key_hash=m.digest()

		m = hashlib.md5()
		m.update(iv.encode('utf-8'))
		iv_hash=m.digest()

		encryptor = AES.new(key_hash, AES.MODE_CBC, IV=iv_hash)

		ret= encryptor.decrypt(bytes(data))

	return ret
