# General-purpose Photovoltaic Device Model gpvdm.com - a drift diffusion
# base/Shockley-Read-Hall model for 1st, 2nd and 3rd generation solarcells.
# The model can simulate OLEDs, Perovskite cells, and OFETs.
# 
# Copyright (C) 2008-2020 Roderick C. I. MacKenzie
# All rights reserved.
# 
# https://www.gpvdm.com
# r.c.i.mackenzie at googlemail.com
# 
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#     * Redistributions of source code must retain the above copyright
#       notice, this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above copyright
#       notice, this list of conditions and the following disclaimer in the
#       documentation and/or other materials provided with the distribution.
#     * Neither the name of the GPVDM nor the
#       names of its contributors may be used to endorse or promote products
#       derived from this software without specific prior written permission.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL Roderick C. I. MacKenzie BE LIABLE FOR ANY
# DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.


import sys

global_objects=[]
blocked=False
class objects:
	name=""
	object_pointer=None

def global_object_register(name,pointer):
	global global_objects
	found=False
	for i in range(0,len(global_objects)):
		if global_objects[i].name==name:
			global_objects[i].object_pointer=pointer
			found=True

	if found==False:
		a=objects()
		a.name=name
		a.object_pointer=pointer
		global_objects.append(a)


def global_object_get(name):
	global global_objects
	for i in range(0,len(global_objects)):
		if global_objects[i].name==name:
			return global_objects[i].object_pointer

	print("name",name,"not found")
	sys.exit()

def global_object_run(name):
	global blocked
	if blocked==True:
		return
	global global_objects
	for i in range(0,len(global_objects)):
		if global_objects[i].name==name:
			blocked=True
			global_objects[i].object_pointer()
			blocked=False
			return


def global_isobject(name):
	global global_objects
	for i in range(0,len(global_objects)):
		if global_objects[i].name==name:
			return True

	return False

def global_object_delete(name):
	global global_objects
	for i in range(0,len(global_objects)):
		if global_objects[i].name==name:
			del global_objects[i]
			return
