# General-purpose Photovoltaic Device Model gpvdm.com - a drift diffusion
# base/Shockley-Read-Hall model for 1st, 2nd and 3rd generation solarcells.
# The model can simulate OLEDs, Perovskite cells, and OFETs.
# 
# Copyright (C) 2008-2020 Roderick C. I. MacKenzie
# All rights reserved.
# 
# https://www.gpvdm.com
# r.c.i.mackenzie at googlemail.com
# 
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#     * Redistributions of source code must retain the above copyright
#       notice, this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above copyright
#       notice, this list of conditions and the following disclaimer in the
#       documentation and/or other materials provided with the distribution.
#     * Neither the name of the GPVDM nor the
#       names of its contributors may be used to endorse or promote products
#       derived from this software without specific prior written permission.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL Roderick C. I. MacKenzie BE LIABLE FOR ANY
# DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.


import os
import random
from tab_base import tab_base
from help import my_help_class
from cal_path import get_image_file_path

import i18n
_ = i18n.language.gettext

#qt
from PyQt5.QtWidgets import QMainWindow, QTextEdit, QAction, QApplication
from PyQt5.QtGui import QIcon,QPixmap,QPalette
from PyQt5.QtCore import QSize, Qt
from PyQt5.QtWidgets import QWidget,QScrollArea,QSizePolicy,QHBoxLayout,QPushButton,QDialog,QFileDialog,QToolBar, QMessageBox, QVBoxLayout, QGroupBox, QTableWidget,QAbstractItemView, QTableWidgetItem, QLabel
from cal_path import get_html_path

class information(QScrollArea,tab_base):

	lines=[]
	edit_list=[]
	file_name=""
	line_number=[]
	save_file_name=""
	name="Welcome"

	def __init__(self):
		QScrollArea.__init__(self)
		self.main_widget=QWidget()

		hbox=QHBoxLayout()
		self.setStyleSheet("background-color:white;");
		self.label = QLabel()
		#self.label.setStyleSheet("background-color:white;");

		self.label.setAlignment(Qt.AlignTop)
		self.label.setOpenExternalLinks(True);
		#self.label.setSizePolicy( QSizePolicy.Ignored, QSizePolicy.Ignored );
		#self.label.setMaximumSize( QSize(16777215, 16777215) )
		self.label.setWordWrap(True)

		files=os.listdir(get_html_path())
		info_files=[]
		for i in range(0,len(files)):
			if files[i].startswith("info") and files[i].endswith("html"):
				info_files.append(files[i])
		file_name=random.choice(info_files)

		f = open(os.path.join(get_html_path(),file_name), encoding='utf-8')
		data = f.readlines()
		f.close()
		text=""
		for i in range(0, len(data)):
			line=data[i]
			line=bytes(line, 'utf-8').decode('utf-8', 'ignore')
			text=text+'\n'+data[i].rstrip()

		text=text.replace("get_image_file_path()",get_image_file_path())

		self.label.setText(text)
		#self.label.setMinimumSize( QSize(0,0) )

		hbox.addWidget(self.label)

		#image = QLabel()
		#pixmap = QPixmap(os.path.join(get_image_file_path(),"image.jpg"))
		#image.setPixmap(pixmap)

		#hbox.addWidget(image)

		self.main_widget.setLayout(hbox)
		self.main_widget.show()
		self.setWidget(self.main_widget)

	def update(self):
		print("")

	def help(self):
		my_help_class.help_set_help(["icon.png",_("<big><b>Welcome to gpvdm</b></big>\n The window will provide you with information about new versions and bugs in gpvdm.")])


