# General-purpose Photovoltaic Device Model gpvdm.com - a drift diffusion
# base/Shockley-Read-Hall model for 1st, 2nd and 3rd generation solarcells.
# The model can simulate OLEDs, Perovskite cells, and OFETs.
# 
# Copyright (C) 2008-2020 Roderick C. I. MacKenzie
# All rights reserved.
# 
# https://www.gpvdm.com
# r.c.i.mackenzie at googlemail.com
# 
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#     * Redistributions of source code must retain the above copyright
#       notice, this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above copyright
#       notice, this list of conditions and the following disclaimer in the
#       documentation and/or other materials provided with the distribution.
#     * Neither the name of the GPVDM nor the
#       names of its contributors may be used to endorse or promote products
#       derived from this software without specific prior written permission.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL Roderick C. I. MacKenzie BE LIABLE FOR ANY
# DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.


import win32pipe
import win32file
import winerror
from threading import Thread

#qt
from PyQt5.QtCore import QSize, Qt
from PyQt5.QtGui import QIcon
from PyQt5.QtWidgets import QWidget
from PyQt5.QtGui import QPixmap
from PyQt5.QtCore import pyqtSignal
from PyQt5.QtWidgets import QWidget

class win_pipe(QWidget):
	new_data = pyqtSignal(str)

	def __init__(self):
		QWidget.__init__(self)

	def rod(self,p):
		while(1):
			#print "going to read"
			try:
				res,data = win32file.ReadFile(p, 4096)
				#print res,data
				if res != winerror.ERROR_MORE_DATA:
					data=data.decode("utf-8")
					self.new_data.emit(data)
				else:
					print("no more data")
					break
			except:
				print("pipe closed")
				break
#		win32pipe.DisconnectNamedPipe(p)


	def foo(self,n):
		while(1):
			p = win32pipe.CreateNamedPipe(r'\\.\pipe\gpvdm_pipe',
				win32pipe.PIPE_ACCESS_INBOUND,
				win32pipe.PIPE_TYPE_MESSAGE | win32pipe.PIPE_WAIT,
				255, 65536, 65536,300,None)

			win32pipe.ConnectNamedPipe(p, None)

			th = Thread(target=self.rod, args=(p,))
			th.daemon = True
			th.start()

	def start(self):
		p = Thread(target=self.foo, args=(10,))
		p.daemon = True
		p.start()


