//
//  General-purpose Photovoltaic Device Model gpvdm.com- a drift diffusion
//  base/Shockley-Read-Hall model for 1st, 2nd and 3rd generation solarcells.
// 
//  Copyright (C) 2012 Roderick C. I. MacKenzie <r.c.i.mackenzie@googlemail.com>
//
//	www.rodmack.com
//	Room B86 Coates, University Park, Nottingham, NG7 2RD, UKf
//
//
// This program is free software; you can redistribute it and/or modify it
// under the terms and conditions of the GNU General Public License,
// version 2, as published by the Free Software Foundation.
//
// This program is distributed in the hope it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
// more details.


#ifndef thermal_h
#define thermal_h
#include "sim.h"
void update_heat(struct device *in);
void dump_thermal(struct simulation *sim,struct device *in);
int solve_thermal(struct simulation *sim,struct device *in);
void thermal_init(struct device *in);
void thermal_free(struct device *in);
double get_thermal_error(struct device *in);
double get_last_thermal_error();
#endif
